[build-system]
requires = ["setuptools"]
build-backend = "setuptools.build_meta"

[project]
name = "mirror-builder"
authors = [
    {name = "Mark McLoughlin", email="markmc@redhat.com"},
    {name = "Doug Hellmann", email="dhellmann@redhat.com"},
]
description = "Wheel mirror builder"
dynamic = ["version"]
classifiers = [
    "Development Status :: 5 - Production/Stable",
    "Environment :: Console",
    "Intended Audience :: Developers",
    "License :: OSI Approved :: BSD License",
    "Operating System :: OS Independent",
    "Programming Language :: Python",
    "Programming Language :: Python :: 3",
    "Programming Language :: Python :: 3 :: Only",
    "Programming Language :: Python :: 3.11",
    "Programming Language :: Python :: 3.12",
    "Programming Language :: Python :: Implementation :: CPython",
    "Topic :: Utilities",
]

requires-python = ">=3.9"

dependencies = [
    "fromager",
    "packaging",
    "python-gitlab",
]

[project.optional-dependencies]
test = [
    "pytest",
    "pytest-cov",
    "coverage!=4.4,>=4.0",
]

[project.entry-points."mirror_builder.project_overrides"]
# This test plugin should stay in the package.
mirror_builder_test = "mirror_builder.example_override"

flit_core = "package_plugins.flit_core"
pyarrow = "package_plugins.pyarrow"
torch = "package_plugins.torch"
triton = "package_plugins.triton"

[tool.setuptools]
packages = [
    "mirror_builder",
    "package_plugins",
]

[tool.isort]
known_first_party=["mirror_builder"]
skip_glob=[
  ".tox/*",    # test runner environment
  "work-dir*", # test runner output
  "tox_env",   # CI job venv
]
